#ifndef __KdTreeApp_H__
#define __KdTreeApp_H__

#include "ExampleApplication.h"
#include "TestKdTreeAppListener.h"

#include <ivreader.h>

class KdTreeApp : public ExampleApplication
{
public:

	KdTreeApp()	{ mFrameListener = 0; }

	~KdTreeApp()
	{
		delete mFrameListener;
	}

protected:
	SceneNode *mDeathNode;
	Camera *mTopCam;
	Camera *mFollowCam;
	KdTreeAppListener *mFrameListener;

	String  mSceneFiles;
	String	mSelectedSceneManager;
	Real	mMoveSpeed;
	Real	mRotateSpeed;
	Real	mRotationRadius;
	Real	mRotationPeriod;
	int		mModelSpacing;
	int		mModelCount;
	int		mRandomCount;
	Real	mPlaneDim;
	bool	mShadowsEnabled;
	int		mSelectEntities;

	virtual void setupResources(void);

	virtual void createScene(void);

	virtual void createFrameListener(void);
	
	virtual void chooseSceneManager(void);

    virtual void createCamera(void);

	virtual void createViewports(void);

    /** Configures the application - returns false if the user chooses to abandon configuration. */
    virtual bool configure(void);

	bool loadScene(const String& filename);
	bool loadSceneIV(const String &filename, SceneNode *root, const int index);
private:
	std::string cat(std::string name, int x, int z)
	{
		std::stringstream s;
		s.fill('0');
		s << name;
		s.width(2);
		s << x;
		s.width(2);
		s << z;
		return s.str();
	}
};

#endif